/**
 * 360View js
 *
 * last update : 2014/07/18
 **/


// 360View
oimc.rotation360 = oimc.rotation360 || {};

$(function(){
	// ------------------------------------------------------------------------
	// 360View
	// ------------------------------------------------------------------------
	oimc.rotation360.ImagePath = [];
	oimc.rotation360.Image = [];
	oimc.rotation360.nowImageNum = 0;
	oimc.rotation360.maxImageNum = 0;
	oimc.rotation360.alt         = '';

	var $rat360BaseObj = $('.box360View');
	var $ratImg;
	var $viewA;
	var $viewImg;
	var $viewItems;
	var $noscript;

	function rat360ObjCheck(){
		$rat360BaseObj = $('.box360View');
		$viewA = $rat360BaseObj.children('a');
		$viewImg = $viewA.children('img');
		$viewItems = $rat360BaseObj.find('li');
		$noscript = $rat360BaseObj.find('.noscript');

		if( $rat360BaseObj.length > 0 ){
			// HACK: underIE8
			if( uaNtv.ltIE8 ){
				$viewImg.css({ cursor:'e-resize' })
			};

			var w = $rat360BaseObj.width(),
				h = $rat360BaseObj.height();

			$noscript.hide();
			$rat360BaseObj.css({ position:'relative', height:h });

			rat360LoadingImgAdd();
		};
	};

	function rat360LoadingImgAdd(){
		// loading img
		$rat360BaseObj.append( '<div id="loadingPart" style="width:100%; text-align: center; position:relative; opacity:0;"><img src="/content/000000016.gif" style="opacity:1;"></div>' );

		// Delete cursor
		$viewImg.css({ cursor:'auto' })

		var h = $rat360BaseObj.height()

		$('#loadingPart img').css({ opacity:1 })

		$rat360BaseObj.find('#loadingPart')
			.stop()
			.css({ top: h / 2 - 30 })
			.animate({
				opacity:1
			},{
				duration:400,
				complete: rat360DataParse
			});
	};

	function rat360DataParse(){
		var i             = 1,
			len           = $viewItems.length,
			embedUrl      = '',
			beginImageNum = 0,
			maxImageNum   = 0,
			alt           = '';

		// parse
		for ( i = 0; i < 1; i++ ) {
			beginImageNum = $rat360BaseObj.eq(i).find('.begin').index();
			maxImageNum   = len;
			alt           = $rat360BaseObj.eq(i).find('li').first().attr('alt');
		};

		oimc.rotation360.alt = alt;

		// imagePath push
		for( i = beginImageNum; i < maxImageNum; i++ ){
			oimc.rotation360.ImagePath.push( $viewItems.eq(i).find('img').attr('src') );
		};

		var loadedCounter = 0,
			len2 = oimc.rotation360.ImagePath.length;

		loadImges();

		// Load img
		function loadImges() {
			var imgObj = new Image();

			$( imgObj ).bind("load", function(){
				loadedCounter++;
				oimc.rotation360.Image.push( imgObj );

				if ( loadedCounter === len2 ) {
					rotation360viewImageLoaded();
				} else {
					loadImges();
				};
			});

			imgObj.src = oimc.rotation360.ImagePath[loadedCounter];
		};
	};

	function rotation360viewImageLoaded(){
		// Delete loadingImg
		$rat360BaseObj.find('#loadingPart')
			.stop()
			.animate({
				opacity:0
			},{
				duration: 300,
				complete:function(){
					$(this).remove();
				}
			});

		setTimeout(function(){
			// Add icon
			$rat360BaseObj.append('<img src="/content/000006504.png" style="opacity:0; position:absolute; z-index:51" id="r360iconCont">');

			// Create img
			$rat360BaseObj.append('<img src=' + oimc.rotation360.ImagePath[0] + ' alt=' + oimc.rotation360.alt + ' style="opacity:0; z-index:50" id="r360img">');

			// HACK: underIE8
			if( uaNtv.ltIE8 ){
				$viewImg.css({ cursor:'e-resize' })
			};

			$rat360BaseObj.css({ height:'' });

			// addEventListener
			rotation360AddEvent();

			//
			iconAnimete();

			beginAnime();

			// Show camera image
			$rat360BaseObj.find('#r360img')
				.stop()
				.animate({
					opacity:1
				},{
					duration: 1000
				});
		}, 300);

		oimc.rotation360.maxImageNum = oimc.rotation360.ImagePath.length;
	};


	function beginAnime(){
		if( inertiaCnt >= oimc.rotation360.maxImageNum ){
			inertiaCnt = 0;
		} else {
			inertiaCnt++;

			var ratSpeed = 1 + inertiaCnt;

			if( inertiaCnt > 40 ){
				inertiaCnt = 40;
			};

			setTimeout( function(){
				var num = 0;

				if( (endUpPt - beginDownPt) < 0) {
					num = +1;
				} else {
					num = -1;
				}
				rotationBeginSetTimeout(num)
			}, ratSpeed);
		};
	};

	function rotationBeginSetTimeout( num ){
		oimc.rotation360.nowImageNum += num;
		lotate360Func();
		beginAnime();
	};

	$(window).on('resize', rotate360RisizeHandler);

	function rotate360RisizeHandler(){
		$(window).off('resize', rotate360RisizeHandler)

		if( $('#r360iconCont').length === 0 ){
			return;
		};

		var boxW = $rat360BaseObj.css('width').replace('px', '') * 1,
			boxH = $rat360BaseObj.find('#r360img').css('height').replace('px', '') * 1;

		var iconW = 100;//$rat360BaseObj.find('#r360iconCont').css('width').replace('px', '') * 1;

		$rat360BaseObj.find('#r360iconCont')
			.stop()
			//.css({ top:50, top : boxH - 10, left:(boxW + iconW) / 2 - 100 });
			.css({ top:100 + '%', left:50 + '%', marginTop:-50, marginLeft:-48 });

		setTimeout(function(){
			$(window).on('resize', rotate360RisizeHandler)
		},30 );
	}

	function iconAnimete(){
		if( $('#r360iconCont').length === 0 ){
			return;
		};

		var boxW = $rat360BaseObj.css('width').replace('px', '') * 1,
			boxH = $rat360BaseObj.find('#r360img').css('height').replace('px', '') * 1;

		var iconW = 100;//$rat360BaseObj.find('#r360iconCont').css('width').replace('px', '') * 1;

		$rat360BaseObj.find('#r360iconCont');

		setTimeout(function(){
			// Show icon
			$rat360BaseObj.find('#r360iconCont')
				.stop()
				//.css({ top:50, left:(boxW + iconW) / 2 - 100, opacity:0 })
				.css({ top:50 + '%', left:50 + '%', marginLeft:-48 })
				.animate({
					opacity:1,
					//top : boxH - 10
					top: 100 + '%',
					marginTop: -50
				},{
					duration: 500,
					easing: 'easeOutBack'
				});
		}, 650);
	};

	function rotation360AddEvent(){
		// addEvent
		$ratImg = $rat360BaseObj.find('#r360img');

		$rat360BaseObj.find('img').on('mousedown', rotation360viewMouseDownHandler );
		$rat360BaseObj.find('img').on('touchstart', rotation360viewMouseDownHandler );

		$(document).on('keydown', rotation360KeyboadEventHandler );

		$viewA.on('click', function(e) {
			e.preventDefault();
		});
	};

	var beginDownPt = 0;
	endUpPt = 0;
	beginTime = 0;
	endTime = 0;
	culcBasePt = 0;

	function rotation360viewMouseDownHandler(e){
		e.preventDefault();

		// HACK: underIE8
		if( !uaNtv.ltIE8 ){
			// Change cursol shape
			$ratImg.css({ 'cursor': 'url(/content/000024684.cur), url(/content/000024685.png), e-resize' });
			$('.box360View').css({ 'cursor': 'url(/content/000024684.cur), url(/content/000024685.png), e-resize' });
		};

		// Delete icon
		var $icon = $('#r360iconCont');

		if( $icon.length > 0){

			$icon.stop()
				.animate({
					opacity:0
				},{
					duration:500,
					complete:function(){
						$icon.remove();
					}
				});
		};

		// addEventLisnet
		$rat360BaseObj.on('mousemove', rotation360viewMouseMoveHandler );
		$rat360BaseObj.on('mouseup', rotation360viewMouseUpHandler );
		$rat360BaseObj.on('mouseout', rotation360viewMouseUpHandler );
		$rat360BaseObj.on('touchmove', rotation360viewMouseMoveHandler );
		$rat360BaseObj.on('touchend', rotation360viewMouseUpHandler );

		//beginDownPt = ( Math.floor( e.pageX / 10 ) ) * 10;

		beginTime = new Date();

		beginDownPt = e.pageX || e.originalEvent.changedTouches[0].pageX;;
		culcBasePt = beginDownPt;
	};

	function rotation360viewMouseUpHandler(e){
		e.preventDefault();

		if( e.type === 'mouseout' ){
			if( $(e.relatedTarget).attr('id') === 'r360img' ){
				return;
			};

			if( $(e.target).attr('class') !== 'box360View' ){
				return;
			};
		};

		// HACK: underIE8
		if( !uaNtv.ltIE8 ){
			// Change cursol shape
			$ratImg.css({ 'cursor': 'url(/content/000000035.cur), url(/content/000000036.png), e-resize' });
			$('.box360View').css({ 'cursor': '' });
		};

		// removeEventLisnet
		$rat360BaseObj.off('mousemove', rotation360viewMouseMoveHandler );
		$rat360BaseObj.off('mouseup', rotation360viewMouseUpHandler );
		$rat360BaseObj.off('mouseout', rotation360viewMouseUpHandler );
		$rat360BaseObj.off('touchmove', rotation360viewMouseMoveHandler );
		$rat360BaseObj.off('touchend', rotation360viewMouseUpHandler );

		endTime = new Date();
		endUpPt = e.pageX || e.originalEvent.changedTouches[0].pageX;

		var valueTime = endTime - beginTime;
		valueDist = Math.abs(endUpPt - beginDownPt);

		if( valueTime > 30 && valueTime < 300 && valueDist > 50 ){
			rotationInertia();
		};
	};

	var inertiaCnt = 0;

	function rotationInertia(){
		if( inertiaCnt >= 10 ){
			inertiaCnt = 0;
		} else {
			inertiaCnt++;

			setTimeout( function(){
				var num = 0;

				if( (endUpPt - beginDownPt) < 0) {
					num = +1;
				} else {
					num = -1;
				};

				rotationSetTimeout(num);
			}, 5 + inertiaCnt + 2);
		};
	};

	function rotationSetTimeout( num ){
		oimc.rotation360.nowImageNum += num;
		lotate360Func();
		rotationInertia();
	}

	function rotation360KeyboadEventHandler(e) {
		// Delete icon
		var $icon = $('#r360iconCont');

		if( $icon.length > 0){
			$icon.stop()
				.animate({
					opacity:0
				},{
					duration:500,
					complete:function(){
						$icon.remove();
					}
				});
		};

		var keyCode = e.keyCode;
		arrow = {left: 37, up: 38, right: 39, down: 40 };

		if( keyCode === arrow.left ){
			oimc.rotation360.nowImageNum++;
		} else if( keyCode === arrow.right ){
			oimc.rotation360.nowImageNum--;
		} else {
			return;
		};

		lotate360Func();
	};

	function rotation360viewMouseMoveHandler(e){
		e.preventDefault();

		var ptX = e.clientX || e.originalEvent.changedTouches[0].pageX;

		var value = ptX - culcBasePt;

		if ( value > 4 ){
			culcBasePt = ptX;
			oimc.rotation360.nowImageNum--;
			lotate360Func();
		}else if( value < -4 ){
			culcBasePt = ptX;
			oimc.rotation360.nowImageNum++;
			lotate360Func();
		};
	};

	function lotate360Func() {
		// check
		if( oimc.rotation360.nowImageNum > oimc.rotation360.maxImageNum - 1 ){
			oimc.rotation360.nowImageNum = 0;
		} else if ( oimc.rotation360.nowImageNum <= -1 ){
			oimc.rotation360.nowImageNum = oimc.rotation360.maxImageNum - 1;
		};

		$ratImg.attr({ src: oimc.rotation360.ImagePath[ oimc.rotation360.nowImageNum ] } );
	};

	$(window).on('load', rat360ObjCheck );
});